module FeynmanDiagramGenerator

using Reexport
@reexport using QEDbase
@reexport using QEDcore
@reexport using QEDprocesses

include("QEDprocesses_patch.jl")

import Base.==
import QEDbase.process

export FlatMatrix

export GenericQEDProcess, isphysical

export AbstractTreeLevelFeynmanDiagram, FeynmanVertex, FeynmanDiagram
export external_particles, virtual_particles, process

export VirtualParticle, number_contributions
export contributions, in_contributions, out_contributions
export is_virtual, particle_pairs

export Forest

export plane_trees, labelled_plane_trees, feynman_diagrams

export can_interact
export QED

include("flat_matrix.jl")

include("trees/labelled_plane_trees.jl")
include("trees/trees.jl")
include("trees/iterator.jl")
include("trees/print.jl")

include("qft/qft.jl")

include("generic_process_def.jl")

include("diagrams/interface.jl")
include("diagrams/vertex.jl")
include("diagrams/diagrams.jl")
include("diagrams/iterator.jl")
include("diagrams/QED.jl")

end # module FeynmanDiagramGenerator
