# patch QEDprocesses
# see issue https://github.com/QEDjl-project/QEDprocesses.jl/issues/77


function _number_particles_helper(
    particles::Tuple{}, species::SPECIES, n::Val{N}
) where {SPECIES,N}
    return N
end

function _number_particles_helper(
    particles::Tuple{SPECIES,Vararg}, species::SPECIES2, n::Val{N}
) where {SPECIES,SPECIES2,N}
    return _number_particles_helper(particles[2:end], species, Val(N))
end

function _number_particles_helper(
    particles::Tuple{SPECIES,Vararg}, species::SPECIES, n::Val{N}
) where {SPECIES,N}
    return _number_particles_helper(particles[2:end], species, Val(N + 1))
end

@inline function QEDprocesses.number_particles(
    proc_def::AbstractProcessDefinition, dir::DIR, species::PT
) where {DIR<:ParticleDirection,PT<:AbstractParticleType}
    return _number_particles_helper(particles(proc_def, dir), species, Val(0))
end

"""
    number_particles(proc_def::AbstractProcessDefinition, particle::AbstractParticleStateful)

Return the number of particles of the given particle's direction and species in the given process definition.
"""
@inline function QEDbase.number_particles(
    proc_def::AbstractProcessDefinition, ps::AbstractParticleStateful
)
    return number_particles(proc_def, particle_direction(ps), particle_species(ps))
end
